WebRequestDataBinder (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.web.bind.support

## Class WebRequestDataBinder

- java.lang.Object
- - org.springframework.validation.DataBinder
  - - org.springframework.web.bind.WebDataBinder
    - - org.springframework.web.bind.support.WebRequestDataBinder

- All Implemented Interfaces:
    PropertyEditorRegistry, TypeConverter

      public class WebRequestDataBinder
      extends WebDataBinder

  Special `DataBinder` to perform data binding from web request parameters to JavaBeans, including support for multipart files.

  See the DataBinder/WebDataBinder superclasses for customization options, which include specifying allowed/required fields, and registering custom property editors.

  Can also used for manual data binding in custom web controllers or interceptors that build on Spring's `WebRequest` abstraction: e.g. in a `WebRequestInterceptor` implementation. Simply instantiate a WebRequestDataBinder for each binding process, and invoke `bind` with the current WebRequest as argument:

       MyBean myBean = new MyBean();
       // apply binder to custom target object
       WebRequestDataBinder binder = new WebRequestDataBinder(myBean);
       // register custom editors, if desired
       binder.registerCustomEditor(...);
       // trigger actual binding of request parameters
       binder.bind(request);
       // optionally evaluate binding errors
       Errors errors = binder.getErrors();
       ...

  Since:
    2.5.2
  Author:
    Juergen Hoeller
  See Also:
    `bind(org.springframework.web.context.request.WebRequest)`, `DataBinder.registerCustomEditor(java.lang.Class<?>, java.beans.PropertyEditor)`, `DataBinder.setAllowedFields(java.lang.String...)`, `DataBinder.setRequiredFields(java.lang.String...)`, `WebDataBinder.setFieldMarkerPrefix(java.lang.String)`

- - ### Field Summary

    - ### Fields inherited from class org.springframework.web.bind.WebDataBinder

      `DEFAULT_FIELD_DEFAULT_PREFIX, DEFAULT_FIELD_MARKER_PREFIX`

    - ### Fields inherited from class org.springframework.validation.DataBinder

      `DEFAULT_AUTO_GROW_COLLECTION_LIMIT, DEFAULT_OBJECT_NAME, logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WebRequestDataBinder(Object target)` Create a new WebRequestDataBinder instance, with default object name.
    `WebRequestDataBinder(Object target, String objectName)` Create a new WebRequestDataBinder instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `bind(WebRequest request)` Bind the parameters of the given request to this binder's target, also binding multipart files in case of a multipart request.
    `void` | `closeNoCatch()` Treats errors as fatal.

    - ### Methods inherited from class org.springframework.web.bind.WebDataBinder

      `bindMultipart, bindMultipartFiles, checkFieldDefaults, checkFieldMarkers, doBind, getEmptyValue, getFieldDefaultPrefix, getFieldMarkerPrefix, isBindEmptyMultipartFiles, setBindEmptyMultipartFiles, setFieldDefaultPrefix, setFieldMarkerPrefix`

    - ### Methods inherited from class org.springframework.validation.DataBinder

      `addValidators, applyPropertyValues, bind, checkAllowedFields, checkRequiredFields, close, convertIfNecessary, convertIfNecessary, convertIfNecessary, findCustomEditor, getAllowedFields, getAutoGrowCollectionLimit, getBindingErrorProcessor, getBindingResult, getConversionService, getDisallowedFields, getErrors, getInternalBindingResult, getObjectName, getPropertyAccessor, getPropertyEditorRegistry, getRequiredFields, getSimpleTypeConverter, getTarget, getTypeConverter, getValidator, getValidators, initBeanPropertyAccess, initDirectFieldAccess, isAllowed, isAutoGrowNestedPaths, isIgnoreInvalidFields, isIgnoreUnknownFields, registerCustomEditor, registerCustomEditor, replaceValidators, setAllowedFields, setAutoGrowCollectionLimit, setAutoGrowNestedPaths, setBindingErrorProcessor, setConversionService, setDisallowedFields, setExtractOldValueForEditor, setIgnoreInvalidFields, setIgnoreUnknownFields, setMessageCodesResolver, setRequiredFields, setValidator, validate, validate`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WebRequestDataBinder

          public WebRequestDataBinder(Object target)

      Create a new WebRequestDataBinder instance, with default object name.
      Parameters:
        `target` - the target object to bind onto (or `null` if the binder is just used to convert a plain parameter value)
      See Also:
        `DataBinder.DEFAULT_OBJECT_NAME`

    - #### WebRequestDataBinder

          public WebRequestDataBinder(Object target,
                              String objectName)

      Create a new WebRequestDataBinder instance.
      Parameters:
        `target` - the target object to bind onto (or `null` if the binder is just used to convert a plain parameter value)
        `objectName` - the name of the target object

  - ### Method Detail

    - #### bind

          public void bind(WebRequest request)

      Bind the parameters of the given request to this binder's target, also binding multipart files in case of a multipart request.

      This call can create field errors, representing basic binding errors like a required field (code "required"), or type mismatch between value and bean property (code "typeMismatch").

      Multipart files are bound via their parameter name, just like normal HTTP parameters: i.e. "uploadedFile" to an "uploadedFile" bean property, invoking a "setUploadedFile" setter method.

      The type of the target property for a multipart file can be MultipartFile, byte[], or String. The latter two receive the contents of the uploaded file; all metadata like original file name, content type, etc are lost in those cases.

      Parameters:
        `request` - request with parameters to bind (can be multipart)
      See Also:
        `MultipartRequest`, `MultipartFile`, `WebDataBinder.bindMultipartFiles(java.util.Map<java.lang.String, org.springframework.web.multipart.MultipartFile>, org.springframework.beans.MutablePropertyValues)`, `DataBinder.bind(org.springframework.beans.PropertyValues)`

    - #### closeNoCatch

          public void closeNoCatch()
                            throws BindException

      Treats errors as fatal.

      Use this method only if it's an error if the input isn't valid. This might be appropriate if all input is from dropdowns, for example.

      Throws:
        `BindException` - if binding errors have been encountered